-- description: stuff i thought was useful for testing with king
-- name: King's Devtools

ACT_KING_DEBUG_MOVE = allocate_mario_action(ACT_GROUP_CUTSCENE | ACT_FLAG_STATIONARY | ACT_FLAG_INTANGIBLE)
ACT_KING_LOCKED = allocate_mario_action(ACT_GROUP_CUTSCENE | ACT_FLAG_STATIONARY | ACT_FLAG_INTANGIBLE)

gKingDevTools = {}
for i = 0, (MAX_PLAYERS - 1) do
    gKingDevTools[i] = {
        ["showStats"] = 0,
        ["levelSelect"] = {
            ["enabled"] = 0,
            ["level"] = 0,
            ["star"] = 1
        },
        ["capSelect"] = {
            ["enabled"] = 0,
            ["cap"] = 0,
        }
    }
end

function wrap_value(value, minimum, maximum)
    if value < minimum then
        value = maximum
    end
    if value > maximum then
        value = minimum
    end
    return value
end

function select_value(m, value, INC_BUTTON, DEC_BUTTON, minimum, maximum)
    if (m.controller.buttonPressed & INC_BUTTON) ~= 0 then
        value = value + 1
        play_sound(SOUND_MENU_CHANGE_SELECT, m.marioObj.header.gfx.cameraToObject)
    end
    if (m.controller.buttonPressed & DEC_BUTTON) ~= 0 then
        value = value - 1
        play_sound(SOUND_MENU_CHANGE_SELECT, m.marioObj.header.gfx.cameraToObject)
    end

    value = wrap_value(value, minimum, maximum)
    return value
end

function mario_update(m)
    local ktools = gKingDevTools[m.playerIndex]

    if m.playerIndex == 0 then

        if ktools.levelSelect.enabled == 1
        or ktools.capSelect.enabled == 1 then
            set_mario_action(m, ACT_KING_LOCKED, 0)
        else
            if m.action == ACT_KING_LOCKED then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end

        if ktools.levelSelect.enabled ~= 0 then
            ktools.levelSelect.level = select_value(m, ktools.levelSelect.level, U_JPAD, D_JPAD, 1, LEVEL_COUNT)
            ktools.levelSelect.star = select_value(m, ktools.levelSelect.star, R_JPAD, L_JPAD, 1, 6)

            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                local warp = warp_to_level(ktools.levelSelect.level, 1, ktools.levelSelect.star)
                if warp == true then
                    ktools.levelSelect.enabled = 0
                else
                    play_sound(SOUND_MENU_CAMERA_BUZZ, m.marioObj.header.gfx.cameraToObject)
                end
            end

            if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                ktools.levelSelect.enabled = 0
            end
        else
            ktools.levelSelect.level = gNetworkPlayers[0].currLevelNum
            ktools.levelSelect.star = 1
        end

        if ktools.capSelect.enabled ~= 0 then
            ktools.capSelect.cap = select_value(m, ktools.capSelect.cap, R_JPAD, L_JPAD, 0, 2)

            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                if ktools.capSelect.cap == 0 then
                    if (m.flags & MARIO_WING_CAP) == 0 then
                        m.flags = m.flags | MARIO_WING_CAP
                    else
                        m.flags = m.flags & ~MARIO_WING_CAP
                    end
                end
                if ktools.capSelect.cap == 1 then
                    if (m.flags & MARIO_VANISH_CAP) == 0 then
                        m.flags = m.flags | MARIO_VANISH_CAP
                    else
                        m.flags = m.flags & ~MARIO_VANISH_CAP
                    end
                end
                if ktools.capSelect.cap == 2 then
                    if (m.flags & MARIO_METAL_CAP) == 0 then
                        m.flags = m.flags | MARIO_METAL_CAP
                    else
                        m.flags = m.flags & ~MARIO_METAL_CAP
                    end
                end

                local capTime = 0
                local capMusic = nil

                if (m.flags & MARIO_VANISH_CAP) ~= 0 then
                    capTime = 600
                    capMusic = SEQ_EVENT_POWERUP
                end
                if (m.flags & MARIO_METAL_CAP) ~= 0 then
                    capTime = 600
                    capMusic = SEQ_EVENT_METAL_CAP
                end
                if (m.flags & MARIO_WING_CAP) ~= 0 then
                    capTime = 1800
                    capMusic = SEQ_EVENT_POWERUP
                end

                if capTime ~= 0 then
                    m.capTimer = max(m.capTimer, capTime)
                else
                    m.capTimer = 0
                end

                if capMusic ~= nil then
                    play_cap_music(capMusic)
                else
                    stop_cap_music()
                end

                ktools.capSelect.enabled = 0
            end

            if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                ktools.capSelect.enabled = 0
            end
        end

        if m.action ~= ACT_KING_LOCKED then
            if (m.controller.buttonPressed & U_JPAD) ~= 0 then
                if m.action == ACT_KING_DEBUG_MOVE then
                    set_mario_action(m, ACT_FREEFALL, 0)
                else
                    set_mario_action(m, ACT_KING_DEBUG_MOVE, 0)
                end
            end

            if (m.controller.buttonPressed & D_JPAD) ~= 0 then
                if ktools.showStats == 0 then
                    ktools.showStats = 1
                else
                    ktools.showStats = 0
                end
            end

            if (m.controller.buttonPressed & L_JPAD) ~= 0 then
                ktools.levelSelect.enabled = 1
            end

            if (m.controller.buttonPressed & R_JPAD) ~= 0 then
                ktools.capSelect.enabled = 1
            end
        end

    end
end

function door_stuff(m)
    local dist = 150
    local doorwarp = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvDoorWarp)
    local door = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvDoor)
    local stardoor = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvStarDoor)

    if doorwarp ~= nil and dist_between_objects(m.marioObj, doorwarp) < dist then

        set_mario_action(m, ACT_WALKING, 0)
        interact_warp_door(m, 0, doorwarp)

    elseif door ~= nil and dist_between_objects(m.marioObj, door) < dist then

        if door.oAction == 0 then
            if (should_push_or_pull_door(m, door) & 1) ~= 0 then
                door.oInteractStatus = 0x00010000
            else
                door.oInteractStatus = 0x00020000
            end
        end

    elseif stardoor ~= nil and dist_between_objects(m.marioObj, stardoor) < dist then

        if stardoor.oAction == 0 then
            stardoor.oInteractStatus = 0x00010000
        end

    end
end

function act_king_debug_move(m)
    local speed = 48

    if (m.controller.buttonDown & B_BUTTON) ~= 0 then
        speed = 64
    end

    set_mario_animation(m, MARIO_ANIM_A_POSE)

    local upDown = 0
    if (m.controller.buttonDown & A_BUTTON) ~= 0 then
        upDown = upDown + 1
    end
    if (m.controller.buttonDown & Z_TRIG) ~= 0 then
        upDown = upDown - 1
    end

    m.vel.y = upDown * speed/2
    m.forwardVel = m.intendedMag/32 * speed

    if m.pos.y == m.floorHeight and m.vel.y <= 0 then
        perform_ground_step(m)
    else
        perform_air_step(m, 0)
    end

    m.faceAngle.y = m.intendedYaw
    m.vel.x = m.forwardVel * sins(m.faceAngle.y)
    m.vel.z = m.forwardVel * coss(m.faceAngle.y)

    door_stuff(m)
end

function act_king_locked(m)
    set_mario_animation(m, MARIO_ANIM_A_POSE)

    m.forwardVel = 0
    perform_air_step(m, 0)

    m.vel.x = 0
    m.vel.y = 0
    m.vel.z = 0
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_mario_action(ACT_KING_DEBUG_MOVE, act_king_debug_move)
hook_mario_action(ACT_KING_LOCKED, act_king_locked)

local levelTable = {
    [LEVEL_UNKNOWN_1] = nil,
    [LEVEL_UNKNOWN_2] = nil,
    [LEVEL_UNKNOWN_3] = nil,
    [LEVEL_BBH] = {["courseNum"] = COURSE_BBH, ["name"] = "TERESA OBAKE"},
    [LEVEL_CCM] = {["courseNum"] = COURSE_CCM, ["name"] = "YYAMA1 % YSLD1"},
    [LEVEL_CASTLE] = {["courseNum"] = COURSE_NONE, ["name"] = "SELECT ROOM"},
    [LEVEL_HMC] = {["courseNum"] = COURSE_HMC, ["name"] = "HORROR DUNGEON"},
    [LEVEL_SSL] = {["courseNum"] = COURSE_SSL, ["name"] = "SABAKU % PYRMD"},
    [LEVEL_BOB] = {["courseNum"] = COURSE_BOB, ["name"] = "BATTLE FIELD"},
    [LEVEL_SL] = {["courseNum"] = COURSE_SL, ["name"] = "YUKIYAMA2"},
    [LEVEL_WDW] = {["courseNum"] = COURSE_WDW, ["name"] = "POOL KAI"},
    [LEVEL_JRB] = {["courseNum"] = COURSE_JRB, ["name"] = "WTDG % TINBOTU"},
    [LEVEL_THI] = {["courseNum"] = COURSE_THI, ["name"] = "BIG WORLD"},
    [LEVEL_TTC] = {["courseNum"] = COURSE_TTC, ["name"] = "CLOCK TOWER"},
    [LEVEL_RR] = {["courseNum"] = COURSE_RR, ["name"] = "RAINBOW CRUISE"},
    [LEVEL_CASTLE_GROUNDS] = {["courseNum"] = COURSE_NONE, ["name"] = "MAIN MAP"},
    [LEVEL_BITDW] = {["courseNum"] = COURSE_BITDW, ["name"] = "EXT1 YOKO SCRL"},
    [LEVEL_VCUTM] = {["courseNum"] = COURSE_VCUTM, ["name"] = "EXT7 HORI MINI"},
    [LEVEL_BITFS] = {["courseNum"] = COURSE_BITFS, ["name"] = "EXT2 TIKA LAVA"},
    [LEVEL_SA] = {["courseNum"] = COURSE_SA, ["name"] = "EXT9 SUISOU"},
    [LEVEL_BITS] = {["courseNum"] = COURSE_BITS, ["name"] = "EXT3 HEAVEN"},
    [LEVEL_LLL] = {["courseNum"] = COURSE_LLL, ["name"] = "FIREB1 % INVLC"},
    [LEVEL_DDD] = {["courseNum"] = COURSE_DDD, ["name"] = "WATER LAND"},
    [LEVEL_WF] = {["courseNum"] = COURSE_WF, ["name"] = "MOUNTAIN"},
    [LEVEL_ENDING] = {["courseNum"] = COURSE_CAKE_END, ["name"] = "ENDING"},
    [LEVEL_CASTLE_COURTYARD] = {["courseNum"] = COURSE_NONE, ["name"] = "URANIWA"},
    [LEVEL_PSS] = {["courseNum"] = COURSE_PSS, ["name"] = "EXT4 MINI SLID"},
    [LEVEL_COTMC] = {["courseNum"] = COURSE_COTMC, ["name"] = "IN THE FALL"},
    [LEVEL_TOTWC] = {["courseNum"] = COURSE_TOTWC, ["name"] = "EXT6 MARIO FLY"},
    [LEVEL_BOWSER_1] = {["courseNum"] = COURSE_BITDW, ["name"] = "KUPPA1"},
    [LEVEL_WMOTR] = {["courseNum"] = COURSE_WMOTR, ["name"] = "EXT8 BLUE SKY"},
    [LEVEL_UNKNOWN_32] = nil,
    [LEVEL_BOWSER_2] = {["courseNum"] = COURSE_BITFS, ["name"] = "KUPPA2"},
    [LEVEL_BOWSER_3] = {["courseNum"] = COURSE_BITS, ["name"] = "KUPPA3"},
    [LEVEL_UNKNOWN_35] = nil,
    [LEVEL_TTM] = {["courseNum"] = COURSE_TTM, ["name"] = "DONKEY % SLID2"},
    [LEVEL_UNKNOWN_37] = nil,
    [LEVEL_UNKNOWN_38] = nil
}

function draw_debug_hud(m)
    local ktools = gKingDevTools[m.playerIndex]

    local x = 22
    local y = djui_hud_get_screen_height() - 31
    local y2 = y - 20
    local y3 = y2 - 20
    local y4 = y3 - 20

    local dpad = {
        ["up"] = get_texture_info("kdev.dpad_up"),
        ["down"] = get_texture_info("kdev.dpad_down"),
        ["left"] = get_texture_info("kdev.dpad_left"),
        ["right"] = get_texture_info("kdev.dpad_right")
    }

    if ktools.levelSelect.enabled == 0
    and ktools.capSelect.enabled == 0 then
        -- debug move
        djui_hud_render_texture(dpad.up, x - 8, y4 - 8, 1, 1)
        djui_hud_render_texture(get_texture_info("kdev.apose"), x*2 - 8, y4 - 8, 1, 1)

        -- down
        djui_hud_render_texture(dpad.down, x - 8, y3 - 8, 1, 1)
        djui_hud_render_texture(get_texture_info("kdev.stats"), x*2, y3, 1, 1)

        -- left
        djui_hud_render_texture(dpad.left, x - 8, y2 - 8, 1, 1)
        djui_hud_render_texture(get_texture_info("kdev.select"), x*2 - 8, y2, 1, 1)

        -- king save
        djui_hud_render_texture(dpad.right, x - 8, y - 8, 1, 1)
        djui_hud_render_texture(get_texture_info("kdev.cap"), x*2, y, 1, 1)

        if ktools.showStats == 1 then
            local steepness = math.sqrt((m.floor.normal.x * m.floor.normal.x) + (m.floor.normal.z * m.floor.normal.z))
            local newY = 5
            local floor_nY = m.floor.normal.y

            local ANG = string.format("ANG %.0f", (atan2s(floor_nY, steepness) * 180) / 32768)
            local SPD = string.format("SPD %.0f", m.forwardVel)
            local STA = string.format("STA %x", (m.action & ACT_ID_MASK))

            djui_hud_print_text(string.upper(ANG):gsub("-", "M"), x, newY + 16, 1)
            djui_hud_print_text(string.upper(SPD):gsub("-", "M"), x, newY + 16*2, 1)
            djui_hud_print_text(string.upper(STA):gsub("-", "M"), x, newY + 16*3, 1)
        end
    else
        -- confirm
        djui_hud_render_texture(get_texture_info("kdev.abutton"), x, y2, 1, 1)
        djui_hud_render_texture(get_texture_info("kdev.tick"), x*2, y2, 1, 1)

        -- exit
        djui_hud_render_texture(get_texture_info("kdev.bbutton"), x, y, 1, 1)
        djui_hud_render_texture(gTextures.no_camera, x*2, y, 1, 1)

        if ktools.levelSelect.enabled == 1 then
            local baseX = djui_hud_get_screen_width()/2 - 320/2
            djui_hud_print_text(tostring(ktools.levelSelect.level), baseX + 40, djui_hud_get_screen_height() - 60, 1)

            djui_hud_set_color(0, 0, 255, 127)
            djui_hud_render_texture(gTextures.star, baseX + 80, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 100, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 120, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 140, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 160, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 180, y3, 1, 1)
            djui_hud_reset_color()

            djui_hud_render_texture(gTextures.star, baseX + 60 + 20*ktools.levelSelect.star - 1.6, y3 - 1.6, 1.2, 1.2)

            local name1 = "UNKNOWN"
            local name2 = "UNKNOWN LEVEL"

            if levelTable[ktools.levelSelect.level] ~= nil then
                name1 = levelTable[ktools.levelSelect.level].name
                name2 = string.upper(get_level_name(levelTable[ktools.levelSelect.level].courseNum, ktools.levelSelect.level, 1))
            end

            djui_hud_print_text(name1, baseX + 80, djui_hud_get_screen_height() - 60, 1)
            djui_hud_print_text(name2, baseX + 80, djui_hud_get_screen_height() - 35, 0.5)
        end

        if ktools.capSelect.enabled == 1 then
            local baseX = djui_hud_get_screen_width()/2
            local box = {
                [0] = get_texture_info("kdev.wingbox"),
                [1] = get_texture_info("kdev.vanishbox"),
                [2] = get_texture_info("kdev.metalbox")
            }

            djui_hud_render_texture(box[0], baseX - 28, y, 0.5, 0.5)
            djui_hud_render_texture(box[1], baseX - 8, y, 0.5, 0.5)
            djui_hud_render_texture(box[2], baseX + 12, y, 0.5, 0.5)

            djui_hud_render_texture(box[ktools.capSelect.cap], baseX - 28 + 20*ktools.capSelect.cap - 1.6, y - 1.6, 0.6, 0.6)
        end
    end
end

hook_event(HOOK_ON_HUD_RENDER_BEHIND, function()
    djui_hud_set_resolution(RESOLUTION_N64)
    djui_hud_set_font(FONT_CUSTOM_HUD)

    local m = gMarioStates[0]

    if m == nil
    or obj_get_first_with_behavior_id(id_bhvActSelector) ~= nil
    or hud_is_hidden() then
        return
    end

    draw_debug_hud(m)
end)